﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using NUnit.Framework;
using Library.Model.Categories;
using Library.Repository.EF;

namespace Library.IntegrationTests
{
	[TestFixture]
	public class EFCategoryRepositoryTests
	{
		[Test]
		public void Can_Add_Category_To_Repository()
		{
			CategoryRepository categoryRepository = new CategoryRepository();

			Category category = new Category();
			category.Name = "Computer Programming";
			category.Description = "Programming Books";

			List<Category> childCategories = new List<Category>();
			childCategories.Add(new Category { Name = "C#", Description = "C# Programming Books" });
			category.ChildCategories = childCategories;

			categoryRepository.Add(category);
			Assert.AreEqual(2, categoryRepository.FindAll().Count);
		}
	}
}
