﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using NUnit.Framework;
using Library.Model;
using Library.Model.Items;
using Library.Model.Authors;
using Library.Repository.EF;

namespace Library.IntegrationTests
{
	[TestFixture]
	public class EFItemRepositoryTests
	{
		[Test]
		public void Can_Add_Book_To_Repository()
		{
			BookRepository bookRepository = new BookRepository();

			Book book = new Book();
			book.Title = "The Java Programming Language";
			book.Description = "Java Programming Series";

			List<Author> authors = new List<Author>();
			Author author1 = new Author {
				FirstName = "James",
				LastName = "Thompson",
				Description = "Java Enterprise Developer"
			};
			Author author2 = new Author {
				FirstName = "Kip",
				LastName = "Irvin",
				Description = "Java Enterprise Developer"
			};
			authors.Add(author1);
			authors.Add(author2);
			book.Authors = authors;
			bookRepository.Add(book);
			Assert.AreEqual(1, bookRepository.FindAll().Count);
		}
		
	}
}
