﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using NUnit.Framework;
using Library.Model;
using Library.Model.Users;
using Library.Repository.EF;

namespace Library.IntegrationTests
{
	[TestFixture]
	public class EFUserRepositoryTests
	{
		[SetUp]
		public void SetUp()
		{
			LibraryContext db = new LibraryContext();
			var objContext = ((System.Data.Entity.Infrastructure.IObjectContextAdapter)db).ObjectContext;
			//objContext.ExecuteStoreCommand("TRUNCATE TABLE [AuthorItem]");
			//objContext.ExecuteStoreCommand("TRUNCATE TABLE [Authors]");
			//objContext.ExecuteStoreCommand("TRUNCATE TABLE [ItemCategory]");
			//objContext.ExecuteStoreCommand("TRUNCATE TABLE [Categories]");
			//objContext.ExecuteStoreCommand("TRUNCATE TABLE [Loans]");
			//objContext.ExecuteStoreCommand("TRUNCATE TABLE [Reservations]");
			//objContext.ExecuteStoreCommand("TRUNCATE TABLE [ItemCopies]");
			//objContext.ExecuteStoreCommand("TRUNCATE TABLE [SavedItems]");
			//objContext.ExecuteStoreCommand("TRUNCATE TABLE [Users]");
			//objContext.ExecuteStoreCommand("TRUNCATE TABLE [Items]");
		}

		[Test]
		public void Can_Add_User_To_Repository()
		{
			UserRepository userRepository = new UserRepository();

			User user = new User();
			user.FirstName = "Tim";
			user.LastName = "Patterson";
			user.EmailAddress = "tim@microsoft.com";
			user.Status = Model.Users.Status.Active;
			user.ContactAddress = new Address("USA", "Vegas", "Walls Fare", "13068");
			
			userRepository.Add(user);
			Assert.AreEqual(1, userRepository.FindAll().Count);

		}
		
	}
}
