﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Library.Model.Items;

namespace Library.Model.Authors
{
	public class Author
	{
		private int _authorId;
		private string _firstName;
		private string _lastName;
		private string _description;
		private IList<Item> _items;
		
		public int AuthorId
		{
			get { return _authorId; }
			set { _authorId = value; }
		}	

		public string FirstName
		{
			get { return _firstName; }
			set { _firstName = value; }
		}

		public string LastName
		{
			get { return _lastName; }
			set { _lastName = value; }
		}

		public string Description
		{
			get { return _description; }
			set { _description = value; }
		}

		public virtual IList<Item> Items
		{
			get { return _items; }
			set { _items = value; }
		}

		public List<BrokenBusinessRule> GetBrokenRules()
		{
			List<BrokenBusinessRule> brokenRules = new List<BrokenBusinessRule>();

			if (string.IsNullOrEmpty(FirstName))
				brokenRules.Add(new BrokenBusinessRule("FirstName", "You must enter a first name for this author"));
			if (string.IsNullOrEmpty(LastName))
				brokenRules.Add(new BrokenBusinessRule("LastName", "You must enter a last name for this author"));
			if (string.IsNullOrEmpty(Description))
				brokenRules.Add(new BrokenBusinessRule("Description", "You must enter a description for this author"));
			return brokenRules;
		}
	}
}
