﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Library.Model.Items;

namespace Library.Model.Categories
{
	public class Category
	{
		private int _categoryId;
		private string _name;
		private string _description;
		private IList<Item> _items;
		private Category _parentCategory;
		private IList<Category> _childCategories;

		public Category()
		{
			_items = new List<Item>();
			_childCategories = new List<Category>();
		}

		public int CategoryId
		{
			get { return _categoryId; }
			set { _categoryId = value; }
		}

		public string Name
		{
			get { return _name; }
			set { _name = value; }
		}

		public string Description
		{
			get { return _description; }
			set { _description = value; }
		}

		public virtual IList<Item> Items
		{
			get { return _items; }
			set { _items = value; }
		}

		public virtual IList<Category> ChildCategories
		{
			get { return _childCategories; }
			set { _childCategories = value; }
		}

		public virtual Category ParentCategory
		{
			get { return _parentCategory; }
			set { _parentCategory = value; }
		}
		
		public List<BrokenBusinessRule> GetBrokenRules()
		{
			List<BrokenBusinessRule> brokenRules = new List<BrokenBusinessRule>();

			if (string.IsNullOrEmpty(Name))
				brokenRules.Add(new BrokenBusinessRule("Name", "A Name must be defined for a category."));
			if (string.IsNullOrEmpty(Description))
				brokenRules.Add(new BrokenBusinessRule("Description", "A Description must be defined for a category."));
			return brokenRules;
		} 
	}
}
