﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Library.Model.Authors;
using Library.Model.Categories;
using Library.Model.ItemCopies;
using Library.Model.SavedItems;

namespace Library.Model.Items
{
	public abstract class Item
	{
		private int _itemId;
		private DateTime? _publicationDate;
		private string _description;
		private string _title;
		private IList<Category> _categories;
		private IList<ItemCopy> _copies;
		private IList<SavedItem> _savedItems;
		private IList<Author> _authors;

		public int ItemId
		{
			get { return _itemId; }
			set { _itemId = value; }
		}

		public DateTime? PublicationDate
		{
			get { return _publicationDate; }
			set { _publicationDate = value; }
		}

		public string Description
		{
			get { return _description; }
			set { _description = value; }
		}

		public string Title
		{
			get { return _title; }
			set { _title = value; }
		}

		public virtual IList<Category> Categories
		{
			get { return _categories; }
			set { _categories = value; }
		}

		public virtual IList<ItemCopy> Copies
		{
			get { return _copies; }
			set { _copies = value; }
		}

		public virtual IList<SavedItem> SavedItems
		{
			get { return _savedItems; }
			set { _savedItems = value; }
		}

		public virtual IList<Author> Authors
		{
			get { return _authors; }
			set { _authors = value; }
		}

		public List<BrokenBusinessRule> GetBrokenRules()
		{
			List<BrokenBusinessRule> brokenRules = new List<BrokenBusinessRule>();

			if (string.IsNullOrEmpty(Title))
				brokenRules.Add(new BrokenBusinessRule("Title", "You must enter a title for this item."));
			if (string.IsNullOrEmpty(Description))
				brokenRules.Add(new BrokenBusinessRule("Description", "You must enter a valid description for this item"));
			return brokenRules;
		}

	}
}
