﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Library.Model;

namespace Library.Repository.EF
{
	public abstract class BaseRepository<T> : IRepository<T> where T : class
	{
		private LibraryContext db;

		public BaseRepository()
		{
			db = new LibraryContext();
		}

		public void Save(T obj)
		{
			if (db.Entry(obj) != null)
				db.Entry(obj).State = EntityState.Modified;
			else
				db.Set<T>().Add(obj);				
			db.SaveChanges();
		}

		public void Add(T obj)
		{
			db.Set<T>().Add(obj);
			db.SaveChanges();
		}

		public T FindBy(int id)
		{
			return db.Set<T>().Find(id);
		}

		public List<T> FindAll()
		{
			return db.Set<T>().ToList();
		}

		public void Delete(T obj)
		{
			db.Entry(obj).State = EntityState.Deleted;
			db.SaveChanges();
		}
	}
}
