﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Data.Entity;
using Library.Repository.EF.MappingFiles;
using Library.Model;
using Library.Model.Items;
using Library.Model.ItemCopies;
using Library.Model.Users;
using Library.Model.SavedItems;
using Library.Model.Loans;

namespace Library.Repository.EF
{
	public class LibraryContext : DbContext
	{
		public DbSet<Item> Items { get; set; }
		public DbSet<ItemCopy> ItemCopies { get; set; }
		public DbSet<User> Users { get; set; }
		public DbSet<SavedItem> SavedItems { get; set; }
		public DbSet<Loan> Loans { get; set; }

		protected override void OnModelCreating(DbModelBuilder modelBuilder)
		{
			modelBuilder.ComplexType<Address>();
			modelBuilder.Configurations.Add(new SavedItemMap());
			modelBuilder.Configurations.Add(new UserMap());
			modelBuilder.Configurations.Add(new ItemMap());
			modelBuilder.Configurations.Add(new AuthorMap());
		}
	}
}
