﻿using System;
using System.Collections.Generic;
using System.Data.Entity.ModelConfiguration;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Library.Model.Items;

namespace Library.Repository.EF.MappingFiles
{
	public class ItemMap : EntityTypeConfiguration<Item>
	{
		public ItemMap()
		{
			this.Map<Book>(m => m.Requires("ItemType").HasValue("B"));
			this.Map<Journal>(m => m.Requires("ItemType").HasValue("J"));

			this.HasMany(i => i.Categories).WithMany(c => c.Items).Map(mc =>
			{
				mc.MapLeftKey("ItemId");
				mc.MapRightKey("CategoryId");
				mc.ToTable("ItemCategory");
			});

		}
	}
}
